module Main where
  
import Crypto.Hash.SHA1
import qualified
       Data.ByteString.Char8  as BS
import Data.Char
import Data.List
import Numeric
import System.Environment
import System.Exit
import System.IO


main 
  = do
    { args <- getArgs
    ; input <- case args of
        []                -> do 
                             { putStr "Enter text to hash: "
                             ; hFlush stdout
                             ; BS.getLine
                             }
        ["--file"]        -> bail lonelyFileOption
        ["--file", fname] -> BS.readFile fname
        [str]             -> return $ BS.pack str
        _                 -> bail tooManyArguments
    ; let octets = concat
                 . intersperse "-"
                 . map (showHex' . ord )
                 . BS.unpack 
                 . hash 
                 $ input
    ; putStrLn octets
    }
  where
    showHex' i = showHex i ""

bail msg
  = do
    { hPutStrLn stderr msg
    ; exitFailure
    }
    
lonelyFileOption = "expected file name after '--file'"
tooManyArguments = "too many arguments"
